%define	origin		ibm
%define	javaver		1.4.0
%define build		0
%define version		%{javaver}.%{build}
%define cvs_version	14
%define javaws_ver	1.2.0
%define javaws_version	1_2_0
%define release		1jpp
%define name		java-%{javaver}-%{origin}
%define	sdklnk		java-%{javaver}-%{origin}
%define	jrelnk		jre-%{javaver}-%{origin}
%define	sdkdir		%{name}-%{version}
%define	jredir		%{sdkdir}/jre
%define sdkbindir	%{_jvmdir}/%{sdkdir}/bin
%define jrebindir	%{_jvmdir}/%{jredir}/bin
%define jvmjardir	%{_jvmjardir}/%{name}-%{version}
%define fontdir		%{_datadir}/fonts/java
%define pluginname	%{jrebindir}/libjavaplugin_oji.so
%define priority	1402
%define section		non-free
%define archive_name	IBMJava2-SDK-%{cvs_version}.tgz
%define toplevel_dir    IBMJava2-%{cvs_version}
%define _x11bindir 	/usr/X11R6/bin
%define _x11encdir	/usr/X11R6/lib/X11/fonts/encodings

Name:		%{name}
Version:	%{version}
Release:	%{release}
Epoch:		0
Summary:	Java Runtime Environment for %{name}
License:	Sun Binary Code License
Group:		Development/Interpreters
Vendor:		JPackage Project
Distribution:	JPackage
URL:		http://www-106.ibm.com/developerworks/java/jdk/linux140
Source0:	%{archive_name}
NoSource:	0
Provides:       jre-%{javaver}-%{origin} = %{epoch}:%{version}, jre-%{javaver},
Provides:       jre-%{origin} = %{epoch}:%{version}, jre = %{javaver}
Provides:       java-%{javaver}, java-%{origin} = %{epoch}:%{version},
Provides:       java = %{javaver}
Requires:	/usr/sbin/update-alternatives
Requires:	jpackage-utils >= 0:1.5.14
Conflicts:	kaffe
BuildArch:	i386
BuildRoot:	%{_tmppath}/%{name}-buildroot
BuildRequires:	jpackage-utils >= 0:1.5, sed
Provides:	javaws = %{javaws_ver}
Provides:	jndi = %{epoch}:%{version}, jndi-ldap = %{epoch}:%{version}
Provides:	jndi-cos = %{epoch}:%{version}, jndi-rmi = %{epoch}:%{version}
Provides:	jaas = %{epoch}:%{version}
Provides:       jsse = %{epoch}:%{version}
Provides:       jce = %{epoch}:%{version}
Provides:	jdbc-stdext = 3.0, jdbc-stdext = %{epoch}:%{version}

%description
This package contains the Java Runtime Environment for %{name}

%package devel
Summary:	Java Development Kit for %{name}
Group:		Development/Compilers
Requires:	/usr/sbin/update-alternatives
Provides:       java-sdk-%{javaver}-%{origin} = %{epoch}:%{version}, java-sdk-%{javaver}
Provides:       java-sdk-%{origin} = %{epoch}:%{version}, java-sdk = %{javaver}
Provides:       java-%{javaver}-devel, java-devel-%{origin} = %{epoch}:%{version}
Provides:       java-devel = %{javaver}
Requires:	%{name} = %{epoch}:%{version}-%{release}

%description devel
The JavaTM Development Kit (JDKTM) contains the software and tools that
developers need to compile, debug, and run applets and applications
written using the Java programming language.

%package src
Summary:	Source files for %{name}
Group:		Development/Interpreters
Requires:	%{name} = %{epoch}:%{version}-%{release}

%description src
This package contains source files for %{name}.

%package demo
Summary:	Demonstration files for %{name}
Group:		Development/Interpreters
Requires:	%{name} = %{epoch}:%{version}-%{release}

%description demo
This package contains demonstrations files for %{name}.

%package plugin
Summary:	Browser plugin files for %{name}
Group:		Internet/WWW/Browsers
Requires:	%{name} = %{epoch}:%{version}-%{release}, %{_bindir}/mozilla
Requires:	%{_bindir}/find, sed
Provides:	java-plugin = %{javaver}, java-%{javaver}-plugin = %{version}
Conflicts:	java-%{javaver}-sun-plugin, java-%{javaver}-blackdown-plugin
Obsoletes:	java-1.3.1-plugin

%description plugin
This package contains browser plugin files for %{name}.

%package jdbc
Summary:	JDBC files for %{name}
Group:		Development/Libraries/Java
Requires:	%{name} = %{epoch}:%{version}-%{release}
AutoReqProv:    no
Requires:	libodbc.so.1
Requires:	libodbcinst.so.1

%description jdbc
This package contains JDBC files for %{name}.

%package fonts
Summary:        TrueType fonts for %{origin} JVMs
Group:          Text Processing/Fonts
Requires:	%{name} = %{epoch}:%{version}-%{release}
Requires:       %{_bindir}/ttmkfdir
Requires:	%{_sbindir}/chkfontpath
Requires:       %{_x11bindir}/mkfontdir
Requires:	perl
Provides:	java-fonts = %{javaver}, java-%{javaver}-fonts
Conflicts:	java-%{javaver}-sun-fonts, java-%{javaver}-blackdown-fonts
Obsoletes:	java-1.3.1-fonts

%description fonts
This package contains the TrueType fonts for %{origin} JVMs.

%prep
rm -rf $RPM_BUILD_ROOT
%setup -n %{toplevel_dir}


%install
# main files
install -d -m 755 $RPM_BUILD_ROOT%{_jvmdir}/%{sdkdir}
cp -a bin include lib src.jar $RPM_BUILD_ROOT%{_jvmdir}/%{sdkdir}
install -d -m 755 $RPM_BUILD_ROOT%{_jvmdir}/%{jredir}
cp -a jre/bin jre/lib $RPM_BUILD_ROOT%{_jvmdir}/%{jredir}

# extensions handling
install -d -m 755 $RPM_BUILD_ROOT%{jvmjardir}
pushd $RPM_BUILD_ROOT%{jvmjardir}
   ln -s %{_jvmdir}/%{jredir}/lib/security.jar jsse-%{version}.jar
   ln -s %{_jvmdir}/%{jredir}/lib/security.jar jce-%{version}.jar
   ln -s %{_jvmdir}/%{jredir}/lib/server.jar jndi-%{version}.jar
   ln -s %{_jvmdir}/%{jredir}/lib/server.jar jndi-ldap-%{version}.jar
   ln -s %{_jvmdir}/%{jredir}/lib/server.jar jndi-cos-%{version}.jar
   ln -s %{_jvmdir}/%{jredir}/lib/server.jar jndi-rmi-%{version}.jar
   ln -s %{_jvmdir}/%{jredir}/lib/security.jar jaas-%{version}.jar
   ln -s %{_jvmdir}/%{jredir}/lib/server.jar jdbc-stdext-%{version}.jar
   ln -s jdbc-stdext-%{version}.jar jdbc-stdext-3.0.jar
   for jar in *-%{version}.jar ; do
      ln -fs ${jar} $(echo $jar | sed "s|-%{version}.jar|-%{javaver}.jar|g")
      ln -fs ${jar} $(echo $jar | sed "s|-%{version}.jar|.jar|g")
   done
popd

# version-less symlinks
pushd $RPM_BUILD_ROOT%{_jvmdir}
ln -s %{jredir} %{jrelnk}
ln -s %{sdkdir} %{sdklnk}
popd

pushd $RPM_BUILD_ROOT%{_jvmjardir}
ln -s %{sdkdir} %{jrelnk}
ln -s %{sdkdir} %{sdklnk}
popd

### font handling

pushd $RPM_BUILD_ROOT/%{_jvmdir}/%{jredir}/lib

   # Remove font.properties and use the system-wide one -- NiM
   rm -f font.properties
   ln -fs %{_sysconfdir}/java/font.properties .

   # remove supplied fonts.dir in preference of the one to be dynamically generated -- Rex
   rm fonts/fonts.dir

   # These %ghost'd files are created properly in %post  -- Rex
   touch fonts/{fonts.{alias,dir,scale,cache-1},XftCache,encodings.dir}

   if [ "%{fontdir}" != "%{jredir}/lib/fonts" ] ; then
      install -d -m 755 $RPM_BUILD_ROOT%{fontdir}
      mv fonts/* $RPM_BUILD_ROOT%{fontdir}
      rmdir fonts
      ln -fs %{fontdir} fonts
   fi

popd

### javaws

HOME=%{buildroot} INSTALL_DIR=%{buildroot} sh jre/bin/webstart_install.sh << EOF
$RPM_BUILD_ROOT%{_jvmdir}/%{jredir}
EOF
rm -f jre/bin/webstart_install.sh
install -d -m 755 $RPM_BUILD_ROOT%{_jvmdir}/%{jredir}/javaws
cp -a javaws/* $RPM_BUILD_ROOT%{_jvmdir}/%{jredir}/javaws
perl -p -i -e 's#javaws\.cfg\.jre\.0\.path=.*#javaws\.cfg\.jre\.0\.path=%{jrebindir}/java#' $RPM_BUILD_ROOT%{_jvmdir}/%{jredir}/javaws/javaws.cfg

rm -f %{buildroot}/.mailcap %{buildroot}/.mime.types

# demo
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/%{name}
cp -a demo $RPM_BUILD_ROOT%{_datadir}/%{name}

# Most of this shamelessly stolen from redhat's kdebase-2.2.2 specfile
find $RPM_BUILD_ROOT%{_jvmdir}/%{jredir} -type d | sed 's|'$RPM_BUILD_ROOT'|%dir |' > $RPM_BUILD_DIR/%{name}-all.files
find $RPM_BUILD_ROOT%{_jvmdir}/%{jredir} -type f | sed 's|'$RPM_BUILD_ROOT'||'      >> $RPM_BUILD_DIR/%{name}-all.files
find $RPM_BUILD_ROOT%{_jvmdir}/%{jredir} -type l | sed 's|'$RPM_BUILD_ROOT'||'      >> $RPM_BUILD_DIR/%{name}-all.files

cat $RPM_BUILD_DIR/%{name}-all.files | grep plugin      | sort > $RPM_BUILD_DIR/%{name}-plugin.files
cat $RPM_BUILD_DIR/%{name}-all.files | grep Jdbc        | sort > $RPM_BUILD_DIR/%{name}-jdbc.files
cat $RPM_BUILD_DIR/%{name}-all.files | grep -v plugin | grep -v Jdbc | grep -v "lib/fonts" | sort > $RPM_BUILD_DIR/%{name}.files

%clean
rm -rf $RPM_BUILD_ROOT
rm -f $RPM_BUILD_DIR/%{name}*.files

%post

update-alternatives --install %{_bindir}/java java %{jrebindir}/java %{priority} \
--slave %{_jvmdir}/jre                     jre                         %{_jvmdir}/%{jredir} \
--slave %{_jvmjardir}/jre                  jre_exports                 %{jvmjardir} \
--slave %{_bindir}/keytool                 keytool                     %{jrebindir}/keytool \
--slave %{_bindir}/policytool              policytool                  %{jrebindir}/policytool \
--slave %{_bindir}/rmid                    rmid                        %{jrebindir}/rmid \
--slave %{_bindir}/rmiregistry             rmiregistry                 %{jrebindir}/rmiregistry \
--slave %{_bindir}/tnameserv               tnameserv                   %{jrebindir}/tnameserv \
--slave %{_datadir}/javaws                 javaws                      %{_jvmdir}/%{jredir}/javaws \
--slave %{_bindir}/ControlPanel             ControlPanel                %{sdkbindir}/JavaPluginControlPanel

update-alternatives --install %{_jvmdir}/jre-%{origin} jre_%{origin} %{_jvmdir}/%{jredir} %{priority} \
--slave %{_jvmjardir}/jre-%{origin}        jre_%{origin}_exports       %{jvmjardir}

update-alternatives --install %{_jvmdir}/jre-%{javaver} jre_%{javaver} %{_jvmdir}/%{jredir} %{priority} \
--slave %{_jvmjardir}/jre-%{javaver}       jre_%{javaver}_exports      %{jvmjardir}

perl -p -i -e "s#application/x-java-jnlp-file.*##" %{_sysconfdir}/mailcap.bak 2>/dev/null
echo "type=application/x-java-jnlp-file; description=\"Java Web Start\"; exts=\"jnlp\"" >> %{_sysconfdir}/mailcap 2>/dev/null

perl -p -i -e "s#application/x-java-jnlp-file.*##" %{_sysconfdir}/mime.types 2>/dev/null
echo "application/x-java-jnlp-file	jnlp" >> %{_sysconfdir}/mime.types 2>/dev/null

%post devel

update-alternatives --install %{_bindir}/javac javac %{sdkbindir}/javac %{priority} \
--slave %{_jvmdir}/java                     java_sdk                    %{_jvmdir}/%{sdkdir} \
--slave %{_jvmjardir}/java                  java_sdk_exports            %{jvmjardir} \
--slave %{_bindir}/appletviewer             appletviewer                %{sdkbindir}/appletviewer \
--slave %{_bindir}/extcheck                 extcheck                    %{sdkbindir}/extcheck \
--slave %{_bindir}/idlj                     idlj                        %{sdkbindir}/idlj \
--slave %{_bindir}/jar                      jar                         %{sdkbindir}/jar \
--slave %{_bindir}/jarsigner                jarsigner                   %{sdkbindir}/jarsigner \
--slave %{_bindir}/javadoc                  javadoc                     %{sdkbindir}/javadoc \
--slave %{_bindir}/javah                    javah                       %{sdkbindir}/javah \
--slave %{_bindir}/javap                    javap                       %{sdkbindir}/javap \
--slave %{_bindir}/jdb                      jdb                         %{sdkbindir}/jdb \
--slave %{_bindir}/native2ascii             native2ascii                %{sdkbindir}/native2ascii \
--slave %{_bindir}/rmic                     rmic                        %{sdkbindir}/rmic \
--slave %{_bindir}/serialver                serialver                   %{sdkbindir}/serialver \
--slave %{_bindir}/HtmlConverter            HtmlConverter               %{sdkbindir}/HtmlConverter

update-alternatives --install %{_jvmdir}/java-%{origin} java_sdk_%{origin} %{_jvmdir}/%{sdkdir} %{priority} \
--slave %{_jvmjardir}/java-%{origin}        java_sdk_%{origin}_exports  %{jvmjardir}

update-alternatives --install %{_jvmdir}/java-%{javaver} java_sdk_%{javaver} %{_jvmdir}/%{sdkdir} %{priority} \
--slave %{_jvmjardir}/java-%{javaver}       java_sdk_%{javaver}_exports %{_jvmjardir}/%{sdkdir}

%post fonts
{
    # Legacy font handling

    #%{_bindir}/ttmkfdir is a requirement anyway -- NiM
    %{_bindir}/ttmkfdir -d %{fontdir} -o %{fontdir}/fonts.scale

    # Fixup lame/broken 0-c-0 entries in fonts.scale -- Rex
    %{_bindir}/perl -pi -e 's@0-c-0@0-p-0@g' %{fontdir}/fonts.scale

    %{_x11bindir}/mkfontdir -e %{_x11encdir} -e %{_x11encdir}/large %{fontdir}

    %{_sbindir}/chkfontpath -q -a %{fontdir}

    # Modern font handling
    # These commands will be executed on upgrade by their respective packages
    if [ -x %{_bindir}/fc-cache ] ; then %{_bindir}/fc-cache -f ; fi

    if [ -x %{_bindir}/redhat-update-gnome-font-install ] ; then
        %{_bindir}/redhat-update-gnome-font-install
    fi

    if [ -x %{_bindir}/redhat-update-gnome-font-install2 ] ; then
        %{_bindir}/redhat-update-gnome-font-install2
    fi

} &> /dev/null || :

%triggerin plugin -- mozilla, %{_bindir}/mozilla
{
   # Read current mozilla root value, deduce plugin dir
   _MOZILLA_PLUGIN_DIR=$(sed -n -e 's|"||g' -e 's|^MOZ_DIST_BIN=\(.*\)$|\1|p' %{_bindir}/mozilla)/plugins

   [ -d "$_MOZILLA_PLUGIN_DIR" ] && ln -sf %pluginname $_MOZILLA_PLUGIN_DIR/libjavaplugin_oji.so
} &> /dev/null || :

%triggerun plugin -- mozilla, %{_bindir}/mozilla
{
   # Do not remove links on upgrade
   [ $2 = 0 ] || exit 0
   # Only remove our own links
   rm -f $(find %{_libdir}/mozilla* -lname %pluginname)
} &> /dev/null || :

%postun plugin
{
   [ $1 = 0 ] || exit 0
   # Only remove our own links
   rm -f $(find %{_libdir}/mozilla* -lname %pluginname)
} &> /dev/null || :

%postun
if [ "$1" = "0" ]; then
	update-alternatives --remove java %{jrebindir}/java
        update-alternatives --remove jre_%{origin}  %{_jvmdir}/%{jredir}
        update-alternatives --remove jre_%{javaver} %{_jvmdir}/%{jredir}
fi

%postun devel
if [ "$1" = "0" ]; then
	update-alternatives --remove javac %{sdkbindir}/javac
        update-alternatives --remove java_sdk_%{origin}  %{_jvmdir}/%{sdkdir}
        update-alternatives --remove java_sdk_%{javaver} %{_jvmdir}/%{sdkdir}
fi

%postun fonts
# Rehash the font dir to keep only stuff manually installed
{
if [ "$1" = "0" ]; then

   if [  $(find %{fontdir} -follow -type f -iname "*.ttf" -printf "\b\b\b\btrue") ] ; then

	%{_bindir}/ttmkfdir -d %{fontdir} -o %{fontdir}/fonts.scale
	%{_x11bindir}/mkfontdir -e %{_x11encdir} -e %{_x11encdir}/large %{fontdir}

   else
        chkfontpath -q -r %{fontdir}
   fi

   if [ -x %{_bindir}/fc-cache ] ; then %{_bindir}/fc-cache -f ; fi

   if [ -x %{_bindir}/redhat-update-gnome-font-install ] ; then
        %{_bindir}/redhat-update-gnome-font-install
   fi

   if [ -x %{_bindir}/redhat-update-gnome-font-install2 ] ; then
        %{_bindir}/redhat-update-gnome-font-install2
    fi
fi
} &> /dev/null || :

%files -f ../%{name}.files
%defattr(-,root,root)
%doc docs/COPYRIGHT docs/japaneseinfo.lnxia32.en.htm docs/japaneseinfo.lnxia32.jp.htm docs/readmefirst.lnxia32.txt
%doc docs/jre docs/rmi-iiop docs/jaas
%dir %{_jvmdir}/%{sdkdir}
%dir %{jvmjardir}
%{_jvmdir}/%{jredir}/lib/fonts
%{jvmjardir}/*.jar
%{_jvmdir}/%{jrelnk}
%{_jvmjardir}/%{jrelnk}

%files devel
%defattr(-,root,root)
%doc docs/sdk/*
%dir %{sdkbindir}
%dir %{_jvmdir}/%{sdkdir}/include
%dir %{_jvmdir}/%{sdkdir}/lib
%{sdkbindir}/*
%{_jvmdir}/%{sdkdir}/include/*
%{_jvmdir}/%{sdkdir}/lib/*
%{_jvmdir}/%{sdklnk}
%{_jvmjardir}/%{sdklnk}

%files src
%defattr(-,root,root)
%{_jvmdir}/%{sdkdir}/src.jar

%files demo
%defattr(-,root,root)
%{_datadir}/%{name}

%files jdbc -f ../%{name}-jdbc.files
%defattr(-,root,root)

%files plugin -f ../%{name}-plugin.files
%defattr(-,root,root)

%files fonts
%defattr(0644,root,root,0755)
%dir %{fontdir}
%{fontdir}/*.ttf
%ghost %{fontdir}/fonts.dir
%ghost %{fontdir}/fonts.scale
%ghost %{fontdir}/fonts.alias
%ghost %{fontdir}/fonts.cache-1
%ghost %{fontdir}/XftCache
%ghost %{fontdir}/encodings.dir

%changelog
* Sat Apr 27 2003 Nicolas Mailhot <Nicolas.Mailhot at laPoste.net> 1.4.0.0-1jpp
- first build
